-----------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.all;
entity gray is
  generic( n : positive := 4);
  port( clk: in std_logic;
         ec: in std_logic;
       clrn: in std_logic;
          q: out std_logic_vector(n-1 downto 0));
end gray;
architecture gray_arch of gray is
COMPONENT CARRY
   PORT (a_in : IN STD_LOGIC;
      a_out: OUT STD_LOGIC);
END COMPONENT;signal d_dummy: std_logic;
signal dummy: std_logic;
signal q_i: std_logic_vector(n-1 downto 0);
signal d_q: std_logic_vector(n-1 downto 0);
signal c_i: std_logic_vector(n-2 downto 0);
signal c_o: std_logic_vector(n-2 downto 0);
begin
q <= q_i;
process(clk,clrn)
begin
  if(clrn = '0')then
    dummy <= '0';
    q_i <= (others => '0');
  elsif(clk'event and clk = '1')then
    if(ec = '1')then
      dummy <= not dummy;
      q_i <= d_q;
    end if;
  end if;
end process;
c_i(0) <= dummy;
d_q(0) <= q_i(0) xor (not(dummy));
g1: for i in 1 to n-2 generate
  c_i(i) <= c_o(i-1) and not q_i(i-1); 
  d_q(i) <= q_i(i) xor (c_o(i-1) and q_i(i-1));
end generate;
d_q(n-1) <= q_i(n-1) xor c_o(n-2);
g2: for i in 0 to n-2 generate 
  cc: carry port map(a_in => c_i(i), a_out => c_o(i));
end generate;
end gray_arch;

